<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, hetedik hét!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>

    <section>
        <title>FUTURE tevékenység editor</title>
        <para>
			Javítsunk valamit a ActivityEditor.java JavaFX programon!
			<link xlink:href="https://github.com/nbatfai/future/tree/master/cs/F6">https://github.com/nbatfai/future/tree/master/cs/F6</link>
			Itt láthatjuk működésben az alapot: <link xlink:href="https://www.twitch.tv/videos/222879467">https://www.twitch.tv/videos/222879467</link>.
        </para>
        <para>
            A programot feléleszteni nem volt teljesen egyszerű.
        </para>
        <para>
            Java 11-től kezdve a JavaFX önálló projetté nőtte ki magát, így már 
            külön csomagkként kell telepítenünk őt.
        </para>
        <para>
            Nálam problémás volt a csomagtelepítés, mivel aki csomagolta a JavaFX-t
            Arch Linux-ra ugyanabba a mappába telepítette a projectet amiben
            az openjdk is telepítve van, ez a JVM  valamilyen bootolási ciklusos
            meghibásodáshoz vezetett.
        </para>
        <para>
             A legjobb és leggyorsabb megoldás az volt,
            hogy letöltöm egyenes az adótól a forrást, s majd én külön "feltelepítem".
        </para>
        <para>
            Másik opció az lett volna, hogy készítek egy saját csomagot, így az
            <emphasis>java-openjfx</emphasis> maintainerévé válnék, szerencsés esetben,
            de ez időigényes eljárás.
        </para>
        <para>
            A <emphasis>javac</emphasis> és <emphasis>java</emphasis> binárisoknak
            meg kell adni a modulok helyét a lemezen, illetve azt is, hogy melyikeket
            akarjuk mi használni, amennyiben JavaFX programokat akarunk fordítani.
        </para>
        <para>
            <emphasis role='bold'>Mi a feladatunk?</emphasis>
        </para>
        <para>
            Ezen a programon javítanunk kell valamit, itt a javítás az lesz, hogy
            átszínezzük a színvilágot, a hagyományhoz hűen a <emphasis role='bodl'>KDE Plasma Dark</emphasis>
            témát fogjuk használni, illetve automatikus fogjuk megjelentíni a szerkesztő paneleket attól függően,
            hogy szerkeszthető elemre kattintottunk-e, ez indikálni fogja, hogy éppen mit hajthatunk végre.
        </para>
        <para>
            A színezéssel kezdjük, ezt nem tudjuk és nem is ajánlatos a programkódban megvalósítani,
            nekünk a stilizálást ki kell vinnünk egy kaszkádolt stíluslapba a megfelelő szabályok alkalmazásával,
            majd a programkódban csupán bindoljuk erre az alkalmazásunkat.
        </para>
        <para>
            A szinek értékeit a LatexLua feladatból származtattam, azok a pontos KDE Plasma Dark értékek.
        </para>
        <para>
            Az összerakása viszont nagyon macerás manuálisan, az űrlapok stílusait általában egy
            speciálisan erre a célra készített programmal(GUI builder) szokták elkészíteni,
            viszont <link xlink:href="https://docs.oracle.com/javafx/2/api/javafx/scene/doc-files/cssref.html">e oldal</link> alapján összeraktam egy minimális stíluslapot.
        </para>
        <programlisting>
            <![CDATA[
.root { 
    -fx-accent: rgb(74,178,239);
    -fx-focus-color: -fx-accent;
    -fx-base: #000;
    -fx-control-inner-background: derive(-fx-base,50%);
    -fx-control-inner-background-alt: derive(-fx-control-inner-background, 30%);
}

.label{
    -fx-text-fill: whitesmoke;
}

.separator *.line { 
    -fx-background-color: rgb(0,0,0);
    -fx-border-style: solid;
    -fx-border-width: 1px;
}

.scroll-bar{
    -fx-background-color: derive(-fx-base,45%)
}            
]]>
        </programlisting>
        <para>
            A másik részfeladat implementálása sem volt túl bonyolult, csupán alapértelmezetten
            elrejtjük a controlokat, majd ha a kiválaszott elem egy szerkeszthető prop fájl
            akkor megjelenítjük, ellenben nem.
        </para>
        <programlisting language='Java'>
            <![CDATA[
 this.setVisible(false);
 this.managedProperty().bind(this.visibleProperty());            
]]>
        </programlisting>
        <para>
            Alapértelmezetten a láthatóság nem befolyásolja a control megrajzolását! Tehát
            láthatatlanul lesz megjelenítve, de helyet fog elfoglalni, ahhoz hogy összekapcsoljuk
            a két viselkedést a rajzolást rákötjük a kezelésre, így ha nem látható akkor nem
            lesz renderelve, vagy fordítva.
        </para>
        <para>
            Az ActivityEditor-ban a fájlrendszer struktúráját jelentíti meg a <varname>fileTree</varname>,
            ennek mindig láthatónak kell lennie.
        </para>
        <para>
            Ugyanitt lehetőségünk van szerkeszthető állományok kiválasztására, tehát
            lekérhetjük az aktuálisan kiválaszott állomány nevét és ha az a prop kiterjesztéssel rendelkezik,
            akkor megrajzoljuk a szerkesztőpaneleket.
        </para>
        <para>
            Azaz rákötünk egy lambdát za egér eseménykezelőre:
        </para>
        <programlisting language='Java'>
            <![CDATA[
fileTree.setOnMouseClicked((javafx.scene.input.MouseEvent evt) -> {

            if (evt.getClickCount() == 1) 
            {
                javafx.scene.control.TreeItem<java.io.File> item = fileTree.getSelectionModel().getSelectedItem();
                if(item.getValue().getName().matches(".*\\.props"))
                {
                    System.out.println(item.getValue().getName());
                    if(stringTree.isVisible() == false)
                    {
                        stringTree.setVisible(true);
                        propsEdit.setVisible(true);
                    }
                }
                else
                {
                    stringTree.setVisible(false);
                    propsEdit.setVisible(false);
                }
            }
        });         
]]>
        </programlisting>
    </section>        

    <section>
        <title>OOCWC Boost ASIO hálózatkezelése</title>
        <para>
			Mutassunk rá a scanf szerepére és használatára! <link xlink:href="https://github.com/nbatfai/robocar-emulator/blob/master/justine/rcemu/src/carlexer.ll">https://github.com/nbatfai/robocar-emulator/blob/master/justine/rcemu/src/carlexer.ll</link>
        </para>
        <para>
            Megoldás forrása:  <link xlink:href="https://github.com/nbatfai/robocar-emulator/blob/master/justine/rcemu/src/carlexer.ll">https://github.com/nbatfai/robocar-emulator/blob/master/justine/rcemu/src/carlexer.ll</link>           
        </para>
        <para>
            Ez a feladat egyszer már szerepelt ebben a fejezetben, viszont itt egy kis
            emlékeztető róla a kód alapján:
        </para>
        <para>
            A mellékelt fájl valószínűleg véletlen lett megadva, jobban tudjuk érzékeltetni
            a <function>std::sscanf</function> működését a kliens kód alapján, hiszen
            pontosan amiatt használjuk amit látunk:
        </para>
        <programlisting language="c++">
            <![CDATA[
while ( std::sscanf ( data+nn, "<OK %d %u %u %u>%n", &idd, &f, &t, &s, &n ) == 4 )
{
      nn += n;
      gangsters.push_back ( Gangster {idd, f, t, s} );
}            
]]>
        </programlisting>
        <para>
            Az <function>std::sscanf</function> függvényt használjuk arra, hogy egy fájlleiróból
            olvassunk.
        </para>
        <para>
            A minta alapján mi 4 különböző értéket szeretnénk beolvasni, és ott egy %n is!
        </para>
        <para>
            Mi ez az n? Az n egy mutató amibe a függvény legutóbb beolvasott bájtok mennyiségét fogja
            rakni, ez egy nagyon hasznos tulajdonsága, hiszen Socket-ről olvasunk, nem tudjuk
            mennyit fogunk fogadni, hacsak explicit nem fejlécezzük azt, így addig amíg mit addig
            olvasunk, bár ez NEM az erőssebbik feltétel.
        </para>
        <para>
            Ezt a n értéket hozzáadjuk egy pufferértékhez(nn), hogy követni tudjuk a beolvasott 
            bájtok mennyiségét.
        </para>
        <para>
            Az erős feltétel itt a visszatérési érték, a függvény visszatérési értéke azt mondja, meg
            hogy eltudtuk-e látni értékekkel az argumentumként megadott változókat olvasás során.
        </para>
    </section>

    <section>
        <title>BrainB</title>
        <para>
Mutassuk be a Qt slot-signal mechanizmust ebben a projektben: <link xlink:href="https://github.com/nbatfai/esport-talent-search">https://github.com/nbatfai/esport-talent-search</link>
        </para>
        <para>
            Ez is egy I. fejezetes feladat volt, tehát viziteljük meg újra.
        </para>
        <para>
            A program célja az, hogy megnmérje, hogy meddig vagyunk képesek fókuszállni játékokban,
            itt főleg MOBA-kra történik a mérés, karakterünkre miközben rengeteg effekt, játékos
            teszi ki a képernyőnket. A teszt 10 perces.
        </para>
        <para>
            A programban egy <emphasis role='bold'>Samu</emphasis> megnevezésű entitást kell
            megfigyelés latt tartanunk miközben új, random entitások jönnek létre és izegnek-mozognak
            Samu életterében.
        </para>
        <para>
            A program futtatásához szükségünk van a következőkre: opencv és egy Qt keretrendszer.
        </para>
        <important>
            <title>
                Ubuntun teszteltem a programot
            </title>
            <para>
                Ubuntu alatt telepítenünk kell az <command>libopencv-dev</command> csomagot és
                egy Qt keretrendszert.
            </para>
        </important>
        <para>
            A Qt keretrendszerről már sokszor volt szó, ő egy cross-platform keretrendszer
            aminek ősi ellenfele a .Net keretrendszer, ellentétbe vele, ő teljesen cross-platform,
            a :net csak most kezd el terjeszkedni .Net Core révén különböző platofmrokra.
        </para>
        <para>
            A Qt keretrendszer egyik különlegessége a a Signal&amp;Slot mechanizmusa ami
            lehetőséget ad a különböző események összekapcsolására rettenetesen egyszerűen
            olyan módon, hogy átlátható és szétválasztható marad a kódbázisunk.
        </para>
        <para>
            
        </para>
        <programlisting language='C++'>
            <![CDATA[
BrainBWin::BrainBWin ( int w, int h, QWidget *parent ) : QMainWindow ( parent )
{

//    setWindowTitle(appName + " " + appVersion);
//    setFixedSize(QSize(w, h));

        statDir = appName + " " + appVersion + " - " + QDate::currentDate().toString() + QString::number ( QDateTime::currentMSecsSinceEpoch() );

        brainBThread = new BrainBThread ( w, h - yshift );
        brainBThread->start();

        connect ( brainBThread, SIGNAL ( heroesChanged ( QImage, int, int ) ),
                  this, SLOT ( updateHeroes ( QImage, int, int ) ) );

        connect ( brainBThread, SIGNAL ( endAndStats ( int ) ),
                  this, SLOT ( endAndStats ( int ) ) );

}

//BrainBWin.h fájlból
public slots :

    void updateHeroes ( const QImage &image, const int &x, const int &y );
    //void stats ( const int &t );
    void endAndStats ( const int &t );
};
]]>
        </programlisting>
        <para>
            A fenti példa a <filename>BrainBWin.cpp</filename> fájlban található, itt
            a példa arra, hogy hogyan is működnek a signalok  aslotokkal.
        </para>
        <para>
            Egyértelműen leolvasható, hogyha meghívják (emit) a <function>heroesChanged</function>
            szignált akkor az ablakkezelő(BrainBWin) slotjára állított függvény hívódjon meg a megfelelő
            paraméterekkel. (Nyílván ha megváltozik a hősök belső állapota akkor újrarajzolni lehetséges őket)
        </para>
        <para>
            Minden olyan osztálynak, amelynek van <filename>QObject</filename> őse, lehet szignáljai
            és slotjai.
        </para>
        <para>
            Tulajdonképpen mi itt egy eseménykezelőt láthatunk a Signal&amp;Slot mechanizmusban,
            ha kiválik egy esemény akkor arra callback a slot-ra állított eventhandler.
        </para>
        <formalpara>
            <title>Pár megjegyzések</title>
            <para>
                
            </para>
        </formalpara>
        <para>
            Az eseménykezelő (S&amp;S) a főszálltól külön fut le, tehát nem blokkol,
            egy slotra akár több szignált is köthetünk, egy szignál is akadálynélkül köthető
            több slotra. Ha több slot van egy szignálra állítva akkor sorrentben "hajtódnak végre".
        </para>
        <para>
            Mint a Visual C# esetén például a <function>delegate</function> funkcionalitás, itt is
            szintaktikai cukorról van szó, azaz, absztrakció és indirekt hívások zajlanak le
            a háttérben, ami egyértelműen azt eredményezi, hogy ha sok helyen használjuk ki
            adottságait akkor bizony belassul a programunk, hiszen több extra utasítását kell
            műveltetni processzorunkkal. Ajánlatos ezt figyelembe venni tervezéskor.
        </para>
    </section>     

    <section>
		<title>EPAM: ASCII art</title>
		<para>
			ASCII Art in Java! Implementálj egy Java parancssori programot, ami beolvas egy képet és kirajzolja
			azt a parancssorba és / vagy egy szöveges fájlba is ASCII karakterekkel.
		</para>
		<para>
			<programlisting language="java"><![CDATA[
import java.io.*;
import java.awt.Color;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;

public class ascii{

	public static void convert(BufferedImage image){
		for(int i = 0; i < image.getHeight(); ++i){
			for (int j = 0; j < image.getWidth(); j++) {
				Color pixcol = new Color(image.getRGB(j, i));
				double pixval = ((pixcol.getRed() * 0.3) + (pixcol.getGreen() * 0.59) + (pixcol.getBlue() * 0.11));
				System.out.print(karakter(pixval));
			}
			System.out.println();
		}
	}

	public static char karakter(double ertek){
		char kar = ' ';
		if(ertek >= 240){
			kar = ' ';
		}else if(ertek >= 210){
			kar = '.';
		}else if(ertek >= 190){
			kar = '*';
		}else if(ertek >= 170){
			kar = '+';
		}else if(ertek >= 120){
			kar = '^';
		}else if(ertek >= 110){
			kar = '&';
		}else if(ertek >= 80){
			kar = '8';
		}else if(ertek >= 60){
			kar = '#';
		}else{
			kar = '@';
		}
		return kar;
	}

	public static void main(String[] args){
		try{
		File input = new File("grogu.jpg");
		BufferedImage image = ImageIO.read(input);
		convert(image);

		}catch(Exception e){
			System.out.println("Error. " + e);
		}
	}
}
				]]>
			</programlisting>
		</para>
		<para>
			Ezzel a programmal egy képet alakítunk át ASCII karakterekből álló "képpé", amit a terminálra íratunk ki.
			A <function>File</function> <literal>input</literal> adja meg a program által várt kép nevét és kiterjesztését. Beolvasás után
			átkerül a <literal>BufferedImage</literal> osztályhoz, ami koordinátákká alakítja a kép pixeleit. Ezt felhasználva
			a <function>convert</function> függvénnyel végigmegyünk a kép pixelein (koordinátááin), meghatározzuk az RGB színkódjuk
			alapján, hogy mekkora szürkeárnyalatos érték tartozik hozzájuk, majd ez alapján, hogy milyen karakter kerüljön
			a pixelek helyére. Utóbbi a <function>karakter</function> függvény segítségével történik.
			A kapott karakterekt pedig kiíratjuk, és megyünk tovább a következőkre.
		</para>
		<para>
			Így a következő képből:
		</para>
		<mediaobject>
          <imageobject>
            <imagedata fileref="img/grogu.jpg" scale="100" />
          </imageobject>
        </mediaobject>
        <para>
        	a következő ASCII artot tudjuk generálni (nem fért ki a képernyőre, ezért kell a több kép):
        </para>
        <mediaobject>
          <imageobject>
            <imagedata fileref="img/asciiout1.png" scale="10" />
          </imageobject>
        </mediaobject>
        <mediaobject>
          <imageobject>
            <imagedata fileref="img/asciiout2.png" scale="14" />
          </imageobject>
        </mediaobject>
	</section>

        
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
</chapter>







